<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH . 'serwersms.php';
$modules[] = ABSPATH. '..'. DS .'..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerExtensionSerwersmsSend extends ControllerExtensionSerwersms {

    public function index() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('extension/module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('extension/serwersms/global');
        $this->load->model('extension/serwersms/message');
        $this->load->model('extension/serwersms/customer');

        if ($this->config->get('serwersms_logged'))
            $auth = $this->config->get('serwersms_logged');

        if (!$auth)
            $this->response->redirect($this->url->link('extension/module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));

        $data = array();
        $data['serwersms_logged'] = $auth;

        $fields = array('heading_title_send',
            'text_list_send',
            'entry_phone',
            'entry_sender',
            'entry_limit',
            'entry_unicode',
            'entry_flash',
            'entry_speed',
            'entry_test',
            'entry_type',
            'entry_client',
            'entry_mesaage_text_label',
            'button_send',
            'button_save',
            'button_cancel'
        );

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $fields = array(
            'serwersms_sender'
        );

        foreach ($fields as $field) {
            if (isset($this->request->post[$field])) {
                $data[$field] = $this->request->post[$field];
            } else {
                $data[$field] = $this->config->get($field);
            }
        }
		
        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        $list = $this->api->getSender();
		$data['senders'] = array();
        if (is_array($list) && !empty($list))
            $data['senders'] = $list;

        $list = $this->api->getPreSender();
        if (is_array($list) && !empty($list))
            $data['senders'] = array_merge($data['senders'], $list);

        $customers = $this->model_extension_serwersms_customer->getAll();
        $data['customers'] = $customers;


        $data['sender'] = '';
        if ($this->config->get('serwersms_sender'))
            $data['sender'] = $this->config->get('serwersms_sender');

        $data['types'] = array(
            0 => 'Wszyscy klienci',
            1 => 'Wybrany klient',
            2 => 'Zdefiniowany numer'
        );

        if (!empty($this->request->post)) {

            if (!$this->validate()) {
                $this->session->data['error_warning'] = $this->language->get('form_error');
                $this->response->redirect($this->url->link('extension/serwersms/send', 'token=' . $this->session->data['token'], 'SSL'));
            }

            $type = '';
            if (isset($this->request->post['serwersms_type']))
                $type = $this->request->post['serwersms_type'];

            $phones = array();
            if ($type == 0) {
                if (!empty($data['customers'])) {
                    foreach ($data['customers'] as $customer) {
                        $phones[] = $customer['telephone'];
                    }
                }
            } else if ($type == 1) {
                if (isset($this->request->post['serwersms_client']) && !empty($this->request->post['serwersms_client']))
                    $phones[] = $this->request->post['serwersms_client'];
            }
            else if ($type == 2) {
                if (isset($this->request->post['serwersms_phone']) && !empty($this->request->post['serwersms_phone'])) {
                    $phones = explode(',', $this->request->post['serwersms_phone']);
                }
            }

            if (isset($this->request->post['serwersms_sender']) && $this->request->post['serwersms_sender'] != '')
                $this->api->sender = $this->request->post['serwersms_sender'];

            $temp = array();
            foreach ($phones as $phone) {
                $phone = substr($phone, -9);
                if (strlen($phone) == 9) {
                    $temp[] = '+48' . $phone;
                }
            }
            $this->api->phone = implode(',', array_unique($temp));

            $message = '';
            if (isset($this->request->post['serwersms_text']))
                $message = $this->request->post['serwersms_text'];

            $this->api->message = $message;
            $response = $this->api->sendSMS();
			if (isset($response['ERR'])) {
                $this->session->data['error_warning'] = $response['ERR'];
                $this->response->redirect($this->url->link('extension/serwersms/send', 'token=' . $this->session->data['token'], 'SSL'));
            }
            else if (is_array($response) && !empty($response)) {
                foreach ($response as $r) {
                    $r['type'] = ($this->api->sender != '') ? 'FULL' : 'ECO';
                    $r['sender'] = $this->api->sender;
                    $r['test'] = $this->api->test;
                    if (!$this->model_extension_serwersms_message->save($r))
                        $this->log('Problem z zapisem danych: ' . serialize($r));
                }
				$this->session->data['message_warning'] = $this->language->get('form_success');
            }
           
            $this->response->redirect($this->url->link('extension/serwersms/send', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $data['error_warning'] = '';
        $data['message_warning'] = '';

        if (isset($this->session->data['error_warning']) && !empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = '';
        }
        if (isset($this->session->data['message_warning']) && !empty($this->session->data['message_warning'])) {
            $data['message_warning'] = $this->session->data['message_warning'];
            $this->session->data['message_warning'] = '';
        } else if (isset($this->error['warning']) && !empty($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/serwersms/about', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title_send'),
            'href' => $this->url->link('extension/serwersms/message', 'token=' . $this->session->data['token'], 'SSL')
        );

        $this->document->addScript('view/javascript/validation.js');
        $this->document->addScript('view/javascript/serwersms.js');
        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $data['form_action'] = $this->url->link('extension/serwersms/send', 'token=' . $this->session->data['token'], 'SSL');

        $this->response->setOutput($this->load->view('serwersms/send.tpl', $data));
    }

    private function validate() {

        $valid = true;
        $required = array('serwersms_type', 'serwersms_text');
        foreach ($required as $r) {
            if (!isset($this->request->post[$r]) || $this->request->post[$r] == '') {
                $valid = false;
            }
        }

        return $valid;
    }

}