<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH. '..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerModuleSerwersms extends Controller {

    public $error = array();
    public $api = null;

    public function index() {

        if (!defined('SALT')) {
            define('SALT', '4gfd32lbxdgfd5hgfd5dfs');
        }

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        $auth = false;
        $salt = SALT;

        if ($this->config->get('serwersms_logged'))
            $auth = $this->config->get('serwersms_logged');

        $password = '';
        $encryption = new Encryption($salt);

        $this->load->language('module/serwersms');
        $this->document->setTitle($this->language->get('heading_title'));

        if (($this->request->server['REQUEST_METHOD'] == 'POST')) {

            $this->load->model('setting/setting');

            if (isset($this->request->post['serwersms_username']) || isset($this->request->post['serwersms_password'])) {

                if (!$this->validateUser()) {
                    $this->session->data['error_warning'] = $this->error['warning'];
                    $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
                }

                if (isset($this->request->post['serwersms_password'])) {
                    $password = $this->request->post['serwersms_password'];
                    $this->request->post['serwersms_password'] = $encryption->encrypt($password);
                }

                $this->api->login = $this->request->post['serwersms_username'];
                $this->api->password = $password;
                $valid = $this->api->checkUser();

                if (!$valid) {
                    $this->request->post['serwersms_install'] = true;
                    $this->request->post['serwersms_logged'] = false;
                    $this->model_setting_setting->editSetting('serwersms', $this->request->post);
                    $this->session->data['error_warning'] = $this->language->get('form_user_invalid');
                } else {

                    $this->request->post['serwersms_install'] = true;
                    $this->request->post['serwersms_logged'] = true;
                    $this->request->post['serwersms_limit'] = 10;
                    $this->model_setting_setting->editSetting('serwersms', $this->request->post);
                    $this->session->data['message_warning'] = $this->language->get('form_user_success');
                    $this->cache->delete('serwersms');
                }

                $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
            } else if ($auth) {

                if (!$this->validate()) {
                    $this->session->data['error_warning'] = $this->language->get('form_error');
                    $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
                } else {

                    $fields = array('serwersms_username', 'serwersms_password', 'serwersms_install', 'serwersms_logged');
                    foreach ($fields as $field) {
                        $this->request->post[$field] = $this->config->get($field);
                    }
                    $this->model_setting_setting->editSetting('serwersms', $this->request->post);
                    $this->session->data['message_warning'] = $this->language->get('form_configuration_success');

                    $this->cache->delete('serwersms');
                    $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
                }
            }
        }

        if ($auth) {

            $data['senders'] = array();
            $this->api->password = $encryption->decrypt($this->config->get('serwersms_password'));
            $list = $this->api->getSender();
            if (is_array($list) && !empty($list))
                $data['senders'] = $list;

            $list = $this->api->getPreSender();
            if (is_array($list) && !empty($list))
                $data['senders'] = array_merge($data['senders'], $list);

            $count = $this->api->getCountSms();
            $data['count_sms'] = $count;
        }

        $fields = array('heading_title',
            'text_header_account',
            'text_module',
            'text_header',
            'text_header_message',
            'text_header_config',
            'form_user_success',
            'form_user_invalid',
            'form_configuration_success',
            'form_configuration_reset',
            'entry_username',
            'entry_phone',
            'entry_unicode',
            'entry_flash',
            'entry_speed',
            'entry_test',
            'entry_password',
            'entry_sender',
            'entry_register_flag',
            'entry_register_label',
            'entry_register_value',
            'entry_order_add_flag',
            'entry_order_add_label',
            'entry_order_add_value',
            'entry_order_complete_flag',
            'entry_order_complete_label',
            'entry_order_complete_value',
            'entry_order_processing_flag',
            'entry_order_processing_label',
            'entry_order_processing_value',
            'entry_order_canceled_flag',
            'entry_order_canceled_label',
            'entry_order_canceled_value',
            'entry_order_shipped_flag',
            'entry_order_shipped_label',
            'entry_order_shipped_value',
            'entry_order_processed_flag',
            'entry_order_processed_label',
            'entry_order_processed_value',
            'entry_order_failed_flag',
            'entry_order_failed_label',
            'entry_order_failed_value',
            'entry_order_voided_flag',
            'entry_order_voided_label',
            'entry_order_voided_value',
            'entry_order_refunded_flag',
            'entry_order_refunded_label',
            'entry_order_refunded_value',
            'entry_order_pending_flag',
            'entry_order_pending_label',
            'entry_order_pending_value',
            'entry_limit',
            'button_save',
            'button_cancel',
            'button_reset',
            'modal_title',
            'modal_yes',
            'modal_no'
        );

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
        $data['form_action'] = $this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL');
        $data['reset'] = $this->url->link('module/serwersms/reset', 'token=' . $this->session->data['token'], 'SSL');

        $data['error_warning'] = '';
        $data['message_warning'] = '';
        $data['limits'] = array(5, 10, 25, 50, 100);

        if (isset($this->session->data['error_warning']) && !empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = '';
        }
        if (isset($this->session->data['message_warning']) && !empty($this->session->data['message_warning'])) {
            $data['message_warning'] = $this->session->data['message_warning'];
            $this->session->data['message_warning'] = '';
        } else if (isset($this->error['warning']) && !empty($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        }

        $fields = array(
            'serwersms_username',
            'serwersms_phone',
            'serwersms_unicode',
            'serwersms_flash',
            'serwersms_speed',
            'serwersms_test',
            'serwersms_sender',
            'serwersms_limit',
            'serwersms_register_flag',
            'serwersms_register_value',
            'serwersms_order_add_flag',
            'serwersms_order_add_value',
            'serwersms_order_complete_flag',
            'serwersms_order_complete_value',
            'serwersms_order_processing_flag',
            'serwersms_order_processing_value',
            'serwersms_order_canceled_flag',
            'serwersms_order_canceled_value',
            'serwersms_order_shipped_flag',
            'serwersms_order_shipped_value',
            'serwersms_order_processed_flag',
            'serwersms_order_processed_value',
            'serwersms_order_failed_flag',
            'serwersms_order_failed_value',
            'serwersms_order_voided_flag',
            'serwersms_order_voided_value',
            'serwersms_order_refunded_flag',
            'serwersms_order_refunded_value',
            'serwersms_order_pending_flag',
            'serwersms_order_pending_value'
        );

        foreach ($fields as $field) {
            if (isset($this->request->post[$field])) {
                $data[$field] = $this->request->post[$field];
            } else {
                $data[$field] = $this->config->get($field);
            }
        }

        $data['serwersms_password'] = null;
        $data['serwersms_logged'] = $auth;

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL')
        );

        $this->document->addScript('view/javascript/validation.js');
        $this->document->addScript('view/javascript/serwersms.js');
        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('module/serwersms.tpl', $data));
    }

    public function reset() {

        $this->load->language('module/serwersms');
        $this->load->model('setting/setting');

        $fields = array('serwersms_install');
        foreach ($fields as $field) {
            $this->request->post[$field] = $this->config->get($field);
        }
        $this->model_setting_setting->editSetting('serwersms', $this->request->post);
        $this->session->data['message_warning'] = $this->language->get('form_configuration_reset');

        $this->cache->delete('serwersms');
        $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
    }

    private function validateUser() {

        if (!isset($this->request->post['serwersms_username']) || empty($this->request->post['serwersms_username'])) {
            $this->error['warning'] = $this->language->get('error_username');
        } else if (!isset($this->request->post['serwersms_password']) || empty($this->request->post['serwersms_password'])) {
            $this->error['warning'] = $this->language->get('error_password');
        }

        if ($this->error) {
            return false;
        } else {
            return true;
        }
    }

    private function validate() {

        $valid = true;
        $required = array('serwersms_phone', 'serwersms_limit');
        foreach ($required as $r) {
            if (!isset($this->request->post[$r]) || $this->request->post[$r] == '') {
                $valid = false;
            }
        }

        return $valid;
    }

    private function options() {

        $data = array();
        $data['login'] = $this->config->get('serwersms_username');
        $data['password'] = $this->config->get('serwersms_password');
        $data['flash'] = $this->config->get('serwersms_flash');
        $data['speed'] = $this->config->get('serwersms_speed');
        $data['test'] = $this->config->get('serwersms_test');
        return $data;
    }

    public function install() {

        $this->db->query('CREATE TABLE IF NOT EXISTS `' . DB_PREFIX . 'serwersms_messages` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`test` TINYINT(1) NULL DEFAULT "0",
			`smsid` varchar(15) NOT NULL,
			`number` varchar(20) NOT NULL,
			`sender_id` varchar(20) NULL,
			`type` enum("ECO","FULL") CHARACTER SET utf8 NOT NULL DEFAULT "ECO",
			`status` varchar(25) NOT NULL,
			`report` datetime NOT NULL,
			`froms` varchar(25) NULL,
			`text` text NOT NULL,
			`reason` varchar(150) NULL,
			`created` datetime NOT NULL,
			PRIMARY KEY (`id`), INDEX `smsid` (`smsid`)
        ) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1');

        $this->db->query('CREATE TABLE IF NOT EXISTS `' . DB_PREFIX . 'serwersms_answers` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`smsid` varchar(15) NOT NULL,
			`number` varchar(15) NOT NULL,
			`message` text NOT NULL,
			`date` datetime NOT NULL,
			`created` datetime NOT NULL,
			PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;');

        $this->db->query('CREATE TABLE IF NOT EXISTS `' . DB_PREFIX . 'serwersms_senders` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`name` varchar(255) NOT NULL,
			`system` varchar(255) NULL,
			`agree` varchar(255) NULL,
			`status` varchar(255) NULL,
			`created` datetime NOT NULL,
			PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;');

        $this->db->query('CREATE TABLE IF NOT EXISTS `' . DB_PREFIX . 'serwersms_invoices` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`name` varchar(255) NOT NULL,
			`status` varchar(10) NULL,
			`settled` decimal(10,2) NULL,
			`price` decimal(10,2) NULL,
			`date` datetime NULL,
			`url` varchar(255) NULL,
			`created` datetime NOT NULL,
			PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;');

        $this->load->model('setting/setting');
        $this->model_setting_setting->editSetting('serwersms', array('serwersms_install' => 1, 'serwersms_limit' => 10));

        $this->load->model('user/user_group');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/send');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/answer');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/sender');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/message');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/about');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/status');
        $this->model_user_user_group->addPermission($this->user->getGroupId(), 'access', 'serwersms/invoice');

        $this->load->model('extension/event');
        $this->model_extension_event->addEvent('serwersms', 'pre.customer.add', 'serwersms/event/customer_add');
        $this->model_extension_event->addEvent('serwersms', 'post.order.add', 'serwersms/event/order_add');
        $this->model_extension_event->addEvent('serwersms', 'post.order.history.add', 'serwersms/event/order_edit');
    }

    public function uninstall() {

        $this->load->model('extension/event');
        $this->model_extension_event->deleteEvent('serwersms');

        $this->load->model('setting/setting');
        $this->model_setting_setting->editSetting('serwersms', array());

        $this->load->model('user/user_group');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/send');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/answer');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/sender');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/message');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/about');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/status');
        $this->model_user_user_group->removePermission($this->user->getGroupId(), 'access', 'serwersms/invoice');
    }

}