<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH . 'serwersms.php';
$modules[] = ABSPATH. '..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerSerwersmsAnswer extends ControllerSerwersms {

    public function index() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('serwersms/global');
        $this->load->model('serwersms/answer');

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'id';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'ASC';
        }

        if (isset($this->request->get['page'])) {
            $page = $this->request->get['page'];
        } else {
            $page = 1;
        }

        $filter_data = array(
            'sort' => $sort,
            'order' => $order,
            'start' => ($page - 1) * $this->config->get('serwersms_limit'),
            'limit' => $this->config->get('serwersms_limit')
        );

        $data['answers'] = array();
        $results = $this->model_serwersms_answer->getAll($filter_data);
        $total = $this->model_serwersms_answer->getTotal();

        if (!empty($results)) {
            foreach ($results as $result) {
                $data['answers'][] = $result;
            }
        }

        $fields = array('heading_title', 'text_list', 'modal_title', 'modal_yes', 'modal_no', 'button_synchronize_answer', 'button_export', 'column_id', 'column_smsid', 'column_created', 'column_number', 'column_message', 'column_date', 'text_pagination');

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $data['error_warning'] = '';
        $data['message_warning'] = '';
		
        if (isset($this->session->data['error_warning']) && !empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = '';
        }
        if (isset($this->session->data['message_warning']) && !empty($this->session->data['message_warning'])) {
            $data['message_warning'] = $this->session->data['message_warning'];
            $this->session->data['message_warning'] = '';
        } else if (isset($this->error['warning']) && !empty($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        }

        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('serwersms/about', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . $url, 'SSL')
        );

        $url = '';

        if ($order == 'ASC') {
            $url .= '&order=DESC';
        } else {
            $url .= '&order=ASC';
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['sort_id'] = $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . '&sort=id' . $url, 'SSL');
        $data['sort_smsid'] = $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . '&sort=smsid' . $url, 'SSL');
        $data['sort_number'] = $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . '&sort=number' . $url, 'SSL');
        $data['sort_date'] = $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . '&sort=date' . $url, 'SSL');

		$data['button_synchronize_url'] = $this->url->link('serwersms/answer/synchronize', 'token=' . $this->session->data['token'] . '&sort=status' . $url, 'SSL');
		$data['button_export_xml'] = $this->url->link('serwersms/answer/export', 'token=' . $this->session->data['token'] . '&sort=status' . $url, 'SSL');

        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }

        $pagination = new Pagination();
        $pagination->total = $total;
        $pagination->page = $page;
        $pagination->limit = $this->config->get('serwersms_limit');
        $pagination->url = $this->url->link('serwersms/answer', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');

        $data['pagination'] = $pagination->render();
        $data['results'] = '';
        if ($total != 0)
            $data['results'] = sprintf($this->language->get('text_pagination'), ($total) ? (($page - 1) * $this->config->get('serwersms_limit')) + 1 : 0, ((($page - 1) * $this->config->get('serwersms_limit')) > ($total - $this->config->get('serwersms_limit'))) ? $total : ((($page - 1) * $this->config->get('serwersms_limit')) + $this->config->get('serwersms_limit')), $total, ceil($total / $this->config->get('serwersms_limit')));

        $data['sort'] = $sort;
        $data['order'] = $order;

        $this->document->addScript('view/javascript/serwersms.js');
        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('serwersms/answer.tpl', $data));
    }
	
	public function synchronize() {

		$this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }
		
        $this->load->language('serwersms/global');
        $this->load->model('serwersms/answer');

		$this->api = new SerwersmsRequest();
		$this->api->init($this->options());
	
		$results = $this->api->getAnswers();
		if(is_array($results) && !empty($results)) {
			$this->model_serwersms_answer->removeAll();
			foreach($results as $r) {
				if(!$this->model_serwersms_answer->save($r))
					$this->log('Problem z zapisem odpowiedzi: ' . serialize($r));
			}
		}
		
		$this->session->data['message_warning'] = $this->language->get('form_success_synchronize');
		$this->response->redirect($this->url->link('serwersms/answer', 'token=' . $this->session->data['token'], 'SSL'));
	}
	
	public function export() {
	
		$this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('serwersms/global');
        $this->load->model('serwersms/answer');
		
        $results = $this->model_serwersms_answer->getAll(array());
		$temp = fopen('php://memory', 'w');
		
		$fields = array('id','smsid','numer','treść wiadomości','data','zapisano');
		$delimiter = ';';
		
		fputcsv($temp, $fields, $delimiter);
		if(!empty($results)) {
			foreach ($results as $row) {
				fputcsv($temp, $row, $delimiter);
			}
			fseek($temp, 0);
		}
		
		$file = 'answers_'.date('Y_m_d_H:i:s').'.csv';
		header('Content-Type: application/csv');
		header('Content-Disposition: attachement; filename="'.$file.'";');
		fpassthru($temp);
        
		exit();
	
	}

}