<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH . 'serwersms.php';
$modules[] = ABSPATH. '..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerSerwersmsSender extends ControllerSerwersms {

    public function index() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('serwersms/global');
        $this->load->model('serwersms/sender');

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'id';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'ASC';
        }

        if (isset($this->request->get['page'])) {
            $page = $this->request->get['page'];
        } else {
            $page = 1;
        }

        $filter_data = array(
            'sort' => $sort,
            'order' => $order,
            'start' => ($page - 1) * $this->config->get('serwersms_limit'),
            'limit' => $this->config->get('serwersms_limit')
        );

        $data['senders'] = array();
        $results = $this->model_serwersms_sender->getAll($filter_data);
        $total = $this->model_serwersms_sender->getTotal();

        if (!empty($results)) {
            foreach ($results as $result) {
                $data['senders'][] = $result;
            }
        }

        $fields = array('heading_title_sender', 'text_list_sender', 'modal_title', 'modal_yes', 'modal_no', 'button_add', 'button_synchronize', 'column_id', 'column_status', 'column_created', 'column_name', 'column_system', 'column_agree', 'text_pagination');

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $data['error_warning'] = '';
        $data['message_warning'] = '';

        if (isset($this->session->data['error_warning']) && !empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = '';
        }
        if (isset($this->session->data['message_warning']) && !empty($this->session->data['message_warning'])) {
            $data['message_warning'] = $this->session->data['message_warning'];
            $this->session->data['message_warning'] = '';
        } else if (isset($this->error['warning']) && !empty($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        }

        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('serwersms/about', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title_sender'),
            'href' => $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . $url, 'SSL')
        );

        $url = '';

        if ($order == 'ASC') {
            $url .= '&order=DESC';
        } else {
            $url .= '&order=ASC';
        }

        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data['sort_id'] = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . '&sort=id' . $url, 'SSL');
        $data['sort_name'] = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . '&sort=name' . $url, 'SSL');
        $data['sort_system'] = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . '&sort=system' . $url, 'SSL');
        $data['sort_agree'] = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . '&sort=agree' . $url, 'SSL');
        $data['sort_status'] = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . '&sort=status' . $url, 'SSL');

        $url = '';

        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }

        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }

        $pagination = new Pagination();
        $pagination->total = $total;
        $pagination->page = $page;
        $pagination->limit = $this->config->get('serwersms_limit');
        $pagination->url = $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');

        $data['pagination'] = $pagination->render();
        $data['results'] = '';

        if ($total != 0)
            $data['results'] = sprintf($this->language->get('text_pagination'), ($total) ? (($page - 1) * $this->config->get('serwersms_limit')) + 1 : 0, ((($page - 1) * $this->config->get('serwersms_limit')) > ($total - $this->config->get('serwersms_limit'))) ? $total : ((($page - 1) * $this->config->get('serwersms_limit')) + $this->config->get('serwersms_limit')), $total, ceil($total / $this->config->get('serwersms_limit')));
			
        $data['sort'] = $sort;
        $data['order'] = $order;

        $data['button_add_url'] = $this->url->link('serwersms/sender/add', 'token=' . $this->session->data['token'] . '&sort=id' . $url, 'SSL');
        $data['button_synchronize_url'] = $this->url->link('serwersms/sender/synchronize', 'token=' . $this->session->data['token'] . '&sort=id' . $url, 'SSL');

        $this->document->addScript('view/javascript/serwersms.js');
        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('serwersms/sender.tpl', $data));
    }

    public function add() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('serwersms/global');
        $this->load->model('serwersms/sender');

        $auth = false;
        if ($this->config->get('serwersms_logged'))
            $auth = $this->config->get('serwersms_logged');

        if (!$auth)
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));

        $data = array();
        $data['serwersms_logged'] = $auth;

        $fields = array('heading_title_sender',
            'text_list_sender',
            'entry_name',
            'entry_limit',
            'entry_mesaage_text_label',
            'button_save',
            'button_cancel'
        );

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $fields = array(
            'serwersms_sender'
        );

        foreach ($fields as $field) {
            if (isset($this->request->post[$field])) {
                $data[$field] = $this->request->post[$field];
            } else {
                $data[$field] = $this->config->get($field);
            }
        }
		
        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        if (!empty($this->request->post)) {

            if (!$this->validate()) {
                $this->session->data['error_warning'] = $this->language->get('form_error');
                $this->response->redirect($this->url->link('serwersms/sender/add', 'token=' . $this->session->data['token'], 'SSL'));
            }

            $response = $this->api->addSender($this->request->post['serwersms_name']);
            if (isset($response['ERR'][0]['status'])) {
                $this->session->data['error_warning'] = $response['ERR'][0]['status'];
                $this->response->redirect($this->url->link('serwersms/sender/add', 'token=' . $this->session->data['token'], 'SSL'));
            } else if (isset($response['OK']) && !empty($response['OK'])) {
                foreach ($response['OK'] as $r) {
                    if (!$this->model_serwersms_sender->save($r))
                        $this->log('Problem z zapisem danych: ' . serialize($r));
                }
                $this->session->data['message_warning'] = $this->language->get('form_success_sender');
            }

            $this->response->redirect($this->url->link('serwersms/sender', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $data['error_warning'] = '';
        $data['message_warning'] = '';

        if (isset($this->session->data['error_warning']) && !empty($this->session->data['error_warning'])) {
            $data['error_warning'] = $this->session->data['error_warning'];
            $this->session->data['error_warning'] = '';
        }
        if (isset($this->session->data['message_warning']) && !empty($this->session->data['message_warning'])) {
            $data['message_warning'] = $this->session->data['message_warning'];
            $this->session->data['message_warning'] = '';
        } else if (isset($this->error['warning']) && !empty($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('serwersms/about', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title_sender'),
            'href' => $this->url->link('serwersms/sender', 'token=' . $this->session->data['token'], 'SSL')
        );


        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title_add'),
            'href' => $this->url->link('serwersms/sender/add', 'token=' . $this->session->data['token'], 'SSL')
        );

        $this->document->addScript('view/javascript/validation.js');
        $this->document->addScript('view/javascript/serwersms.js');
        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $data['form_action'] = $this->url->link('serwersms/sender/add', 'token=' . $this->session->data['token'], 'SSL');

        $this->response->setOutput($this->load->view('serwersms/sender_add.tpl', $data));
    }

    public function synchronize() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->load->language('serwersms/global');
        $this->load->model('serwersms/sender');

        $auth = false;
        if ($this->config->get('serwersms_logged'))
            $auth = $this->config->get('serwersms_logged');

        if (!$auth)
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));

        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        $this->model_serwersms_sender->removeAll();
        $list = $this->api->getSender();

        if (is_array($list) && !empty($list)) {
            foreach ($list as $r) {
                if (!$this->model_serwersms_sender->save($r))
                    $this->log('Problem z zapisem danych: ' . serialize($r));
            }
        }

        $this->session->data['message_warning'] = $this->language->get('form_success_synchronize');
        $this->response->redirect($this->url->link('serwersms/sender', 'token=' . $this->session->data['token'], 'SSL'));
    }

    private function validate() {

        $valid = true;
        if (!isset($this->request->post['serwersms_name']) || empty($this->request->post['serwersms_name']))
            $valid = false;

        return $valid;
    }

}