<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH . 'serwersms.php';
$modules[] = ABSPATH. '..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerSerwersmsStatus extends ControllerSerwersms {

    public function index() {

        $this->load->model('setting/setting');
        if ($this->config->get('serwersms_install') != 1) {
            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
        if ($this->config->get('serwersms_logged') != 1) {
            $this->response->redirect($this->url->link('module/serwersms', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        $data = array();
        $data['status'] = $this->api->getStatus();

        $this->load->language('serwersms/global');
        $fields = array('heading_title_status', 'text_list_status', 'text_list_status_user', 'text_list_status_other');

        foreach ($fields as $field) {
            if ($this->language->get($field))
                $data[$field] = $this->language->get($field);
        }

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('serwersms/about', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title_status'),
            'href' => $this->url->link('serwersms/status', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['count_sms'] = array();
        $count = $this->api->getCountSms();
        if (is_array($count) && !empty($count))
            $data['count_sms'] = $count;

        $data['error_warning'] = '';
        $data['message_warning'] = '';

        $prefix = '';
        $domain = $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
        $pos = strpos($domain, 'admin/index.php?route=serwersms');

        if ($pos !== false)
            $prefix = substr($domain, 0, $pos - 1);

        $protocol = stripos($_SERVER['SERVER_PROTOCOL'], 'https') === true ? 'https://' : 'http://';

        $data['serwersms_url_raport'] = '';
        $data['serwersms_url_answer'] = '';

        if ($prefix != '')
            $data['serwersms_url_raport'] = $protocol . $prefix . '/index.php?route=serwersms/raport&smsid=#SMSID#&status=#STAN#&date=#DATA#&reason=#PRZYCZYNA#';
        if ($prefix != '')
            $data['serwersms_url_answer'] = $protocol . $prefix . '/index.php?route=serwersms/answer&smsid=#SMSID#&message=#WIADOMOSC#&date=#DATA#&number=#NUMER#';

        $this->document->addStyle('view/stylesheet/serwersms.css');
        $data['scripts'] = $this->document->getScripts();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('serwersms/status.tpl', $data));
    }

}