<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */

class ModelExtensionSerwersmsAnswer extends Model {

    public $table = 'serwersms_answers';
	
    public function save($data = array()) {

        $fields = array('smsid', 'message', 'date', 'number');
        foreach ($fields as $field) {
            if (!isset($data[$field]))
                $data[$field] = '';
        }

        if (!$this->validate($data))
            return false;

        foreach ($data as $key => $value)
            $data[$key] = $this->db->escape($value);

        $data['created'] = date('Y-m-d H:i:s');
        $sql = "INSERT INTO " . DB_PREFIX . $this->table . " SET smsid = '" . $data['smsid'] . "', number = '" . $data['number'] . "', message = '" . $data['message'] . "', date = '" . $data['date'] . "', created = '" . $data['created'] . "'";

        if ($this->db->query($sql)) {
            return $this->db->getLastId();
        }

        return false;
    }
	
    public function removeAll() {

        $data = array();
        $sql = "TRUNCATE TABLE " . DB_PREFIX . $this->table;

        $query = $this->db->query($sql);
        return (bool) $query;
    }

    public function getAll($data = array()) {

        $result = array();
        $sql = "SELECT * FROM `" . DB_PREFIX . $this->table . "`";

        $sort_data = array('id', 'smsid', 'number', 'date');

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY id";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int) $data['start'] . "," . (int) $data['limit'];
        }

        $query = $this->db->query($sql);

        if (!isset($query->rows) || empty($query->rows))
            return $result;

        foreach ($query->rows as $r) {
            $result[] = $r;
        }

        return $result;
    }

    public function getTotal() {

        $data = array();
        $sql = "SELECT count(*) FROM " . DB_PREFIX . $this->table;

        $query = $this->db->query($sql);
        if (!isset($query->row['count(*)']))
            return 0;

        return (int) $query->row['count(*)'];
    }

    private function validate($data) {

        if (empty($data['smsid']) || empty($data['message']))
            return false;

        return true;
    }

}

?>