<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */

class ModelExtensionSerwersmsInvoice extends Model {

    public $table = 'serwersms_invoices';

    public function getAll($data = array()) {

        $result = array();
        $sql = "SELECT * FROM `" . DB_PREFIX . $this->table . "`";

        $sort_data = array('id', 'name', 'status', 'settled', 'price', 'date', 'url');

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY id";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int) $data['start'] . "," . (int) $data['limit'];
        }

        $query = $this->db->query($sql);

        if (!isset($query->rows) || empty($query->rows))
            return $result;

        foreach ($query->rows as $r) {
            $result[] = $r;
        }

        return $result;
    }

    public function getTotal() {

        $data = array();
        $sql = "SELECT count(*) FROM " . DB_PREFIX . $this->table;

        $query = $this->db->query($sql);
        if (!isset($query->row['count(*)']))
            return 0;

        return (int) $query->row['count(*)'];
    }

    public function removeAll() {

        $data = array();
        $sql = "TRUNCATE TABLE " . DB_PREFIX . $this->table;

        $query = $this->db->query($sql);
        return (bool) $query;
    }

    public function save($data = array()) {

        if (!is_array($data) || empty($data))
            return false;

        if (!isset($data['name']))
            return false;

        $fields = array('status', 'settled', 'price', 'date', 'url');
        foreach ($fields as $field) {
            if (!isset($data[$field]))
                $data[$field] = null;
        }

        $tmp = array();
        foreach ($data as $key => $value)
            $tmp[$key] = $this->db->escape($value);

        $data = $tmp;
        $data['created'] = date('Y-m-d H:i:s');

        $sql = "INSERT INTO " . DB_PREFIX . $this->table . " SET name = '" . $data['name'] . "', status = '" . $data['status'] . "', settled = '" . $data['settled'] . "', price = '" . $data['price'] . "', date = '" . $data['date'] . "', url = '" . $data['url'] . "', created = '" . $data['created'] . "'";
        if ($this->db->query($sql)) {
            return $this->db->getLastId();
        }

        return false;
    }

}

?>