<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */

class ModelSerwersmsMessage extends Model {

    public $table = 'serwersms_messages';

    public function getAll($data = array()) {

        $result = array();
        $sql = "SELECT * FROM `" . DB_PREFIX . $this->table . "`";

        $sort_data = array('id', 'smsid', 'number', 'sender_id', 'type', 'status');

        if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
            $sql .= " ORDER BY " . $data['sort'];
        } else {
            $sql .= " ORDER BY id";
        }

        if (isset($data['order']) && ($data['order'] == 'DESC')) {
            $sql .= " DESC";
        } else {
            $sql .= " ASC";
        }

        if (isset($data['start']) || isset($data['limit'])) {
            if ($data['start'] < 0) {
                $data['start'] = 0;
            }

            if ($data['limit'] < 1) {
                $data['limit'] = 20;
            }

            $sql .= " LIMIT " . (int) $data['start'] . "," . (int) $data['limit'];
        }

        $query = $this->db->query($sql);

        if (!isset($query->rows) || empty($query->rows))
            return $result;

        foreach ($query->rows as $r) {
            $result[] = $r;
        }

        return $result;
    }
	
	
	public function getForSynchronize() {
	
	    $result = array();
		$date = new DateTime();
		$date->modify('-3 days');
		$start = $date->format('Y-m-d H:i:s');
		
        $sql = "SELECT * FROM `" . DB_PREFIX . $this->table . "` WHERE (status='Oczekiwanie' OR status='Wysłano') AND test != 1 AND report > '".$start."'";
		$query = $this->db->query($sql);
        if (!isset($query->rows) || empty($query->rows))
            return $result;

        foreach ($query->rows as $r) {
            $result[] = $r;
        }

        return $result;
	}

    public function getTotal() {

        $data = array();
        $sql = "SELECT count(*) FROM " . DB_PREFIX . $this->table;

        $query = $this->db->query($sql);
        if (!isset($query->row['count(*)']))
            return 0;

        return (int) $query->row['count(*)'];
    }

    public function save($data = array()) {

        if (!is_array($data) || empty($data))
            return false;

        if (!isset($data['smsid']) || !isset($data['number']) || !isset($data['date']) || !isset($data['message']))
            return false;

        $fields = array('status', 'sender_id', 'report');
        foreach ($fields as $field) {
            if (!isset($data[$field]))
                $data[$field] = null;
        }

        $tmp = array();
        foreach ($data as $key => $value)
            $tmp[$key] = $this->db->escape($value);

        $data = $tmp;
        $data['created'] = date('Y-m-d H:i:s');

        $sql = "INSERT INTO " . DB_PREFIX . $this->table . " SET test = '" . $data['test'] . "', smsid = '" . $data['smsid'] . "', number = '" . $data['number'] . "', sender_id = '" . $data['sender'] . "', type = '" . $data['type'] . "', status = '" . $data['status'] . "', report = '" . $data['date'] . "', text = '" . $data['message'] . "', reason = '" . $data['reason'] . "', created = '" . $data['created'] . "'";
        if ($this->db->query($sql)) {
            return $this->db->getLastId();
        }

        return false;
    }
	
	public function update($data = array()) {

        if (!is_array($data) || empty($data) || !isset($data['smsid']) || empty($data['smsid']))
            return false;

        $sql = "SELECT * FROM " . DB_PREFIX . $this->table . " WHERE smsid = '" . $this->db->escape($data['smsid']) . "' LIMIT 1";
        $result = $this->db->query($sql);

        if (!isset($result->num_rows) || $result->num_rows == 0)
            return false;

        if (!isset($result->row) || empty($result->row) || !is_array($result->row))
            return false;

        $row = $result->row;
		
        $fields = array('reason','date', 'from');
        foreach ($fields as $field) {
            if (!isset($data[$field]) && isset($row[$field]))
                $data[$field] = $row[$field];
            else if (!isset($data[$field]) && !isset($row[$field]))
                $data[$field] = '';
        }

        foreach ($data as $key => $value)
            $data[$key] = $this->db->escape($value);
			
		if($data['status']==$row['status'] || $data['status']=='Oczekiwanie') 
			return true;

		$sql = "UPDATE " . DB_PREFIX . $this->table . " SET status = '" . $data['status'] . "', report = '" . $data['date'] . "', reason = '" . $data['reason'] . "', froms = '" . $data['from'] . "' WHERE id = " . $row['id'];
		
		$result = $this->db->query($sql);
        if ($result)
            return true;

        return false;
    }

}

?>