<?php echo $header; ?>
<?php echo $column_left; ?>
<div id="content">

    <div id="serwersms">

        <div class="page-header">
            <div class="container-fluid">
                <h1><?php echo $heading_title; ?></h1>
                <ul class="breadcrumb">
                    <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                    <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                    <?php } ?>
                </ul>
            </div>
        </div>

        <?php if ($error_warning) { ?>
        <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php } ?>

        <?php if ($message_warning) { ?>
        <div class="alert alert-success"><i class="fa fa-check-circle"></i> <?php echo $message_warning; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php } ?>

        <div class="container-fluid">

            <div class="logo">
                <img src="view/image/serwersms_logo.png" alt="" />
            </div>

            <form action="<?php echo $form_action; ?>" method="post" enctype="multipart/form-data" id="form-serwersms" class="form-horizontal validate">

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_header; ?></h3>
                    </div>

                    <div class="panel-body">

                        <div class="form-group">            
                            <label class="col-sm-2 control-label" for="input-username"><?php echo $entry_username; ?></label>
                            <div class="col-sm-10">
                                <input required <?php if(isset($serwersms_logged) && $serwersms_logged==1) echo 'disabled'; ?> type="text" name="serwersms_username" value="<?php echo $serwersms_username; ?>" placeholder="<?php echo $entry_username; ?>" id="input-username" class="form-control" />
						   </div>
                        </div>

                        <div class="form-group">            
                            <label class="col-sm-2 control-label" for="input-password"><?php echo $entry_password; ?></label>
                            <div class="col-sm-10">
                                <input required <?php if(isset($serwersms_logged) && $serwersms_logged==1) { echo 'disabled'; $entry_password = '*****'; } ?> type="password" name="serwersms_password" value="" placeholder="<?php echo $entry_password; ?>" id="input-password" class="form-control" />
							</div>
                        </div>
						
						<div class="col-sm-2"></div>
						<div class="col-sm-10">
							<?php if(!isset($serwersms_logged) || !$serwersms_logged): ?>
								<p>
									Jeśli nie posiadasz jeszcze konta, <a target="_blank" href="http://panel.serwersms.pl/rejestracja">zarejestruj się</a>.
								</p>
							<?php endif; ?>
						</div>

                    </div>
                </div>

                <div class="panel">	

                    <div class="panel-body">
                        <div class="pull-right">
                            <?php if(isset($serwersms_logged) && $serwersms_logged==1): ?>	
                            <a href="<?php echo $reset; ?>" data-toggle="tooltip" title="<?php echo $button_reset; ?>" class="btn btn-danger confirm"><i class="fa fa-refresh"></i></a>
                            <?php else: ?>
                            <button type="submit" form="form-html" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
                            <?php endif; ?>
                        </div>
                    </div>
                </div>

                <?php if(isset($serwersms_logged) && $serwersms_logged==1): ?>

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_header_account; ?></h3>
                    </div>

                    <div class="panel-body">
                        <dl>
                            <dt>SMS ECO:</dt>
                            <dd><?php if(isset($count_sms['ECO'])) echo $count_sms['ECO']; else echo 0; ?></dd>
                            <dt>SMS FULL:</dt>
                            <dd><?php if(isset($count_sms['FULL'])) echo $count_sms['FULL']; else echo 0; ?></dd>
                        </dl>
                    </div>
                </div>

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_header_config; ?></h3>
                    </div>

                    <div class="panel-body">

                        <div class="form-group">  
                            <label class="col-sm-2 control-label" for="input-sender"><?php echo $entry_sender; ?></label>
                            <div class="col-sm-10">
                                <select name="serwersms_sender" id="input-sender" class="form-control">
                                    <option value="" selected="selected">Losowy numer (ECO)</option>
                                    <?php if(isset($senders) && !empty($senders)): ?>
                                    <?php foreach($senders as $s): ?>
                                    <?php if($s['status']=='Autoryzowano'): ?>
                                    <option <?php if(isset($serwersms_sender) && $serwersms_sender==$s['name']) echo ' selected'; ?> value="<?php echo $s['name']; ?>"><?php echo $s['name']; ?></option>
                                    <?php endif; ?>
                                    <?php endforeach; ?>
                                    <?php endif; ?>
                                </select>
                                <p>
                                    <br/>Jeśli pole ustawione jest na wartość (Losowy numer), wiadomość zostanie wysłana jako SMS ECO 
                                </p>
                            </div>
                        </div>

                        <div class="form-group">            
                            <label class="col-sm-2 control-label" for="input-phone"><?php echo $entry_phone; ?></label>
                            <div class="col-sm-10">
                                <input required type="text" name="serwersms_phone" value="<?php echo $serwersms_phone; ?>" placeholder="<?php echo $entry_phone; ?>" id="input-phone" class="form-control" />
                                <p>
                                    <br/>Numer telefonu administratora do powiadomień SMS. Można podać kilka numerów oddzielonych przecinkiem ",". 
                                </p>
                            </div>
                        </div>

                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-unicode"><?php echo $entry_unicode; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_unicode" value="1" <?php if(isset($serwersms_unicode) && $serwersms_unicode==1) echo 'checked="checked"'; ?> id="input-unicode" class="form-control " />
                                       <p>
                                    <br/>Opcja powoduje włączenie kodowania UTF-8, które pozwala na wysyłkę wiadomości ze znakami specjalnymi różnych języków w tym polskich znaków. Redukuje maksymalną długość wiadomości ze 160 do 70 znaków. Opcja dostępna tylko dla SMS FULL. 
                                </p>
                            </div>
                        </div>

                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-flash"><?php echo $entry_flash; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_flash" value="1" <?php if(isset($serwersms_flash) && $serwersms_flash==1) echo 'checked="checked"'; ?> id="input-flash" class="form-control " />
                                       <p>
                                    <br/>Wiadomość SMS z rozszerzeniem typu Flash (z ang. Błysk). Jest to rodzaj wiadomości SMS, która w chwili odebrania automatycznie wyświetla się na ekranie telefonu. W zależności od opcji telefonu, taką wiadomość można od razu usunąć (np. naciskając OK) lub zapisać w skrzynce odbiorczej. 
                                </p>
                            </div>
                        </div>

                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-speed"><?php echo $entry_speed; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_speed" value="1" <?php if(isset($serwersms_speed) && $serwersms_speed==1) echo 'checked="checked"'; ?> id="input-speed" class="form-control " />
                                       <p>
                                    <br/>Wiadomość SMS z rozszerzeniem typu Speed traktowane są priorytetowo oraz wysyłane indywidualnie przez niezależny system. 
                                </p>
                            </div>
                        </div>

                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-test"><?php echo $entry_test; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_test" value="1" <?php if(isset($serwersms_test) && $serwersms_test==1) echo 'checked="checked"'; ?> id="input-test" class="form-control " />
                                       <p>
                                    <br/> Tryb testowy pozwala na sprawdzenie wprowadzonych ustawień bez wysyłania wiadomości i naliczenia kosztów. 
                                </p>
                            </div>
                        </div>

                        <div class="form-group">            
                            <label class="col-sm-2 control-label" for="input-limit"><?php echo $entry_limit; ?></label>
                            <div class="col-sm-10">
                                <select required name="serwersms_limit" id="input-limit" class="form-control">
                                    <?php if(isset($limits)): ?>
                                    <?php foreach($limits as $limit): ?>
                                    <option <?php if($limit==$serwersms_limit) echo 'selected="selected"'; ?> value="<?php echo $limit; ?>"><?php echo $limit; ?></option>
                                    <?php endforeach; ?>
                                    <?php endif; ?>
                                </select>
                            </div>
                        </div>

                    </div>
                </div>

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_header_message; ?></h3>
                    </div>

                    <div class="panel-body">
					
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-register-flag"><?php echo $entry_register_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_register_flag" value="1" <?php if(isset($serwersms_register_flag) && $serwersms_register_flag==1) echo 'checked="checked"'; ?> id="input-register-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-register-value"><?php echo $entry_register_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_register_value" id="input-register-value" class="form-control"><?php if(!empty($serwersms_register_value)) echo $serwersms_register_value; else echo $entry_register_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
                                    {customer} - imię i nazwisko użytkownika<br/>
                                    {email} - adres e-mail użytkownika
                                </p>
                            </div>
                        </div>
						
						<hr />
					
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-add-flag"><?php echo $entry_order_add_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_add_flag" value="1" <?php if(isset($serwersms_order_add_flag) && $serwersms_order_add_flag==1) echo 'checked="checked"'; ?> id="input-order-add-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-add-value"><?php echo $entry_order_add_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_add_value" id="input-order-add-value" class="form-control"><?php if(!empty($serwersms_order_add_value)) echo $serwersms_order_add_value; else echo $entry_order_add_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia<br/>
									{comment} - komentarz zamówienia<br/>
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-processing-flag"><?php echo $entry_order_processing_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_processing_flag" value="1" <?php if(isset($serwersms_order_processing_flag) && $serwersms_order_processing_flag==1) echo 'checked="checked"'; ?> id="input-order-processing-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-processing-value"><?php echo $entry_order_processing_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_processing_value" id="input-order-processing-value" class="form-control"><?php if(!empty($serwersms_order_processing_value)) echo $serwersms_order_processing_value; else echo $entry_order_processing_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-processed-flag"><?php echo $entry_order_processed_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_processed_flag" value="1" <?php if(isset($serwersms_order_processed_flag) && $serwersms_order_processed_flag==1) echo 'checked="checked"'; ?> id="input-order-processed-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-processed-value"><?php echo $entry_order_processed_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_processed_value" id="input-order-processed-value" class="form-control"><?php if(!empty($serwersms_order_processed_value)) echo $serwersms_order_processed_value; else echo $entry_order_processed_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-complete-flag"><?php echo $entry_order_complete_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_complete_flag" value="1" <?php if(isset($serwersms_order_complete_flag) && $serwersms_order_complete_flag==1) echo 'checked="checked"'; ?> id="input-order-complete-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-complete-value"><?php echo $entry_order_complete_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_complete_value" id="input-order-complete-value" class="form-control"><?php if(!empty($serwersms_order_complete_value)) echo $serwersms_order_complete_value; else echo $entry_order_complete_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-shipped-flag"><?php echo $entry_order_shipped_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_shipped_flag" value="1" <?php if(isset($serwersms_order_shipped_flag) && $serwersms_order_shipped_flag==1) echo 'checked="checked"'; ?> id="input-order-shipped-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-shipped-value"><?php echo $entry_order_shipped_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_shipped_value" id="input-order-shipped-value" class="form-control"><?php if(!empty($serwersms_order_shipped_value)) echo $serwersms_order_shipped_value; else echo $entry_order_shipped_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-canceled-flag"><?php echo $entry_order_canceled_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_canceled_flag" value="1" <?php if(isset($serwersms_order_canceled_flag) && $serwersms_order_canceled_flag==1) echo 'checked="checked"'; ?> id="input-order-canceled-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-canceled-value"><?php echo $entry_order_canceled_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_canceled_value" id="input-order-canceled-value" class="form-control"><?php if(!empty($serwersms_order_canceled_value)) echo $serwersms_order_canceled_value; else echo $entry_order_canceled_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
                        <div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-failed-flag"><?php echo $entry_order_failed_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_failed_flag" value="1" <?php if(isset($serwersms_order_failed_flag) && $serwersms_order_failed_flag==1) echo 'checked="checked"'; ?> id="input-order-failed-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-failed-value"><?php echo $entry_order_failed_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_failed_value" id="input-order-failed-value" class="form-control"><?php if(!empty($serwersms_order_failed_value)) echo $serwersms_order_failed_value; else echo $entry_order_failed_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
						<div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-voided-flag"><?php echo $entry_order_voided_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_voided_flag" value="1" <?php if(isset($serwersms_order_voided_flag) && $serwersms_order_voided_flag==1) echo 'checked="checked"'; ?> id="input-order-voided-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-voided-value"><?php echo $entry_order_voided_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_voided_value" id="input-order-voided-value" class="form-control"><?php if(!empty($serwersms_order_voided_value)) echo $serwersms_order_voided_value; else echo $entry_order_voided_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
						<div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-refunded-flag"><?php echo $entry_order_refunded_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_refunded_flag" value="1" <?php if(isset($serwersms_order_refunded_flag) && $serwersms_order_refunded_flag==1) echo 'checked="checked"'; ?> id="input-order-refunded-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-refunded-value"><?php echo $entry_order_refunded_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_refunded_value" id="input-order-refunded-value" class="form-control"><?php if(!empty($serwersms_order_refunded_value)) echo $serwersms_order_refunded_value; else echo $entry_order_refunded_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
						<hr />
						
						<div class="form-group"> 
                            <label class="col-sm-2 text-right" for="input-order-pending-flag"><?php echo $entry_order_pending_flag; ?></label>
                            <div class="col-sm-10">
                                <input type="checkbox" name="serwersms_order_pending_flag" value="1" <?php if(isset($serwersms_order_pending_flag) && $serwersms_order_pending_flag==1) echo 'checked="checked"'; ?> id="input-order-pending-flag" class="form-control " />
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-sm-2 text-right" for="input-order-pending-value"><?php echo $entry_order_pending_label; ?></label>
                            <div class="col-sm-10">
                                <textarea name="serwersms_order_pending_value" id="input-order-pending-value" class="form-control"><?php if(!empty($serwersms_order_pending_value)) echo $serwersms_order_pending_value; else echo $entry_order_pending_value; ?></textarea>
                                <p>
                                    <br/>
                                    Pola personalizacji:<br/>
									{order_id} - ID zamówienia<br/>
									{status} - status zamówienia<br/>
									{customer} - imię i nazwisko zamawiającego<br/>
									{email} - adres e-mail zamawiającego<br/>
									{payment} - metoda płatności<br/>
									{price} - łączna wartość zamówienia
                                </p>
                            </div>
                        </div>
						
                    </div>
                </div>

                <div class="pull-right">
                    <button type="submit" form="form-html" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
                    <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a>
                </div>

                <?php endif; ?>

                <script  type="text/javascript">
                    $('#form-serwersms').validator();
                </script>

            </form>

        </div>
    </div>
</div>

<div id="confirm"  class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title"><?php echo $modal_title; ?></h4>
            </div>
            <div class="modal-footer">
                <button type="button" data-dismiss="modal" class="btn btn-primary" id="yes"><?php echo $modal_yes; ?></button>
                <button type="button" data-dismiss="modal" class="btn"><?php echo $modal_no; ?></button>
            </div>
        </div>
    </div>
</div>

<?php echo $footer; ?>