<?php echo $header; ?>
<?php echo $column_left; ?>
<div id="content">
    <div id="serwersms">
        <div class="page-header">
            <div class="container-fluid">

				<div class="logo">
					<img src="view/image/serwersms_logo.png" alt="" />
				</div>
				
                <div class="pull-right">
                    <a href="<?php echo $button_synchronize_url; ?>" data-toggle="tooltip" title="<?php echo $button_synchronize_answer; ?>" class="btn btn-danger confirm"><i class="fa fa-refresh"></i></a>
                    <a href="<?php echo $button_export_xml; ?>" data-toggle="tooltip" title="<?php echo $button_export; ?>" class="btn btn-primary"><i class="fa fa-file-excel-o"></i></a>
                </div>

                <h1><?php echo $heading_title; ?></h1>
                <ul class="breadcrumb">
                    <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                    <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                    <?php } ?>
                </ul>
            </div>
        </div>
        <div class="container-fluid">
		
            <?php if ($error_warning) { ?>
            <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
                <button type="button" class="close" data-dismiss="alert">&times;</button>
            </div>
            <?php } ?>
			
            <?php if ($message_warning) { ?>
            <div class="alert alert-success"><i class="fa fa-check-circle"></i> <?php echo $message_warning; ?>
                <button type="button" class="close" data-dismiss="alert">&times;</button>
            </div>
            <?php } ?>
			
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><i class="fa fa-list"></i> <?php echo $text_list; ?></h3>
                </div>
                <div class="panel-body">
                    <div class="table-responsive">
                        <?php if (isset($answers) && !empty($answers)): ?>
                        <table class="table table-bordered table-hover">
                            <thead>
                                <tr>
                                    <td class="text-left">
                                        <?php if ($sort == 'id'): ?>
                                        <a href="<?php echo $sort_id; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_id; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_id; ?>"><?php echo $column_id; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'smsid'): ?>
                                        <a href="<?php echo $sort_smsid; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_smsid; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_smsid; ?>"><?php echo $column_smsid; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'number'): ?>
                                        <a href="<?php echo $sort_number; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_number; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_number; ?>"><?php echo $column_number; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left"><?php echo $column_message; ?></td>
                                    <td class="text-left">
                                        <?php if ($sort == 'date'): ?>
                                        <a href="<?php echo $sort_date; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_date; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_date; ?>"><?php echo $column_date; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left"><?php echo $column_created; ?></td>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($answers as $answer): ?>
                                <tr>
                                    <td class="text-left"><?php echo $answer['id']; ?></td>
                                    <td class="text-left"><?php echo $answer['smsid']; ?></td>
                                    <td class="text-left"><?php echo $answer['number']; ?></td>
                                    <td class="text-left"><?php echo $answer['message']; ?></td>
                                    <td class="text-left"><?php echo $answer['date']; ?></td>
                                    <td class="text-left"><?php echo $answer['created']; ?></td>
                                </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                        <?php else: ?>
                        <p>Brak danych.</p>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-sm-6 text-left"><?php echo $pagination; ?></div>
                        <div class="col-sm-6 text-right"><?php echo $results; ?></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div id="confirm"  class="modal fade">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title"><?php echo $modal_title; ?></h4>
      </div>
      <div class="modal-footer">
		<button type="button" data-dismiss="modal" class="btn btn-primary" id="yes"><?php echo $modal_yes; ?></button>
		<button type="button" data-dismiss="modal" class="btn"><?php echo $modal_no; ?></button>
      </div>
    </div>
  </div>
</div>

<?php echo $footer; ?> 