<?php echo $header; ?>
<?php echo $column_left; ?>
<div id="content">
    <div id="serwersms">
        <div class="page-header">
            <div class="container-fluid">

				<div class="logo">
					<img src="view/image/serwersms_logo.png" alt="" />
				</div>

                <div class="pull-right">
                    <a href="<?php echo $button_synchronize_url; ?>" data-toggle="tooltip" title="<?php echo $button_synchronize; ?>" class="btn btn-danger confirm"><i class="fa fa-refresh"></i></a>
                </div>

                <h1><?php echo $heading_title_invoice; ?></h1>
                <ul class="breadcrumb">
                    <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                    <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                    <?php } ?>
                </ul>
            </div>
        </div>
        <div class="container-fluid">

            <?php if ($error_warning) { ?>
            <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
                <button type="button" class="close" data-dismiss="alert">&times;</button>
            </div>
            <?php } ?>

            <?php if ($message_warning) { ?>
            <div class="alert alert-success"><i class="fa fa-check-circle"></i> <?php echo $message_warning; ?>
                <button type="button" class="close" data-dismiss="alert">&times;</button>
            </div>
            <?php } ?>

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><i class="fa fa-list"></i> <?php echo $text_list_invoice; ?></h3>
                </div>
                <div class="panel-body">
                    <div class="table-responsive">
                        <?php if (isset($invoices) && !empty($invoices)): ?>
                        <table class="table table-bordered table-hover">
                            <thead>
                                <tr>
                                    <td class="text-left">
                                        <?php if ($sort == 'id'): ?>
                                        <a href="<?php echo $sort_id; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_id; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_id; ?>"><?php echo $column_id; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'name'): ?>
                                        <a href="<?php echo $sort_name; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_name; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_name; ?>"><?php echo $column_name; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'agree'): ?>
                                        <a href="<?php echo $sort_status; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_paid; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_status; ?>"><?php echo $column_paid; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'settled'): ?>
                                        <a href="<?php echo $sort_settled; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_settled; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_settled; ?>"><?php echo $column_settled; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left">
                                        <?php if ($sort == 'price'): ?>
                                        <a href="<?php echo $sort_price; ?>" class="<?php echo strtolower($order); ?>"><?php echo $column_price; ?></a>
                                        <?php else: ?>
                                        <a href="<?php echo $sort_price; ?>"><?php echo $column_price; ?></a>
                                        <?php endif; ?>
                                    </td>
                                    <td class="text-left"><?php echo $column_created; ?></td>
                                    <td class="text-left"><?php echo $column_action; ?></td>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($invoices as $invoice): ?>
                                <tr>
                                    <td class="text-left"><?php echo $invoice['id']; ?></td>
                                    <td class="text-left"><?php echo $invoice['name']; ?></td>
                                    <td class="text-left"><?php if($invoice['status']==1) echo 'Tak'; else echo 'Nie'; ?></td>
                                    <td class="text-left"><?php echo $invoice['settled']; ?></td>
                                    <td class="text-left"><?php echo $invoice['price']; ?></td>
                                    <td class="text-left"><?php echo $invoice['created']; ?></td>
                                    <td class="text-left">
										<a target="_blank" href="<?php echo $invoice['url']; ?>" data-toggle="tooltip" title="<?php echo $text_download; ?>" class="btn btn-default"><i class="fa fa-download"></i></a
									</td>
                                </tr>
                                <?php endforeach; ?>

                            </tbody>
                        </table>
                        <?php else: ?>
                        <p>Brak danych.</p>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-sm-6 text-left"><?php echo $pagination; ?></div>
                        <div class="col-sm-6 text-right"><?php echo $results; ?></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div id="confirm"  class="modal fade">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title"><?php echo $modal_title; ?></h4>
      </div>
      <div class="modal-footer">
		<button type="button" data-dismiss="modal" class="btn btn-primary" id="yes"><?php echo $modal_yes; ?></button>
		<button type="button" data-dismiss="modal" class="btn"><?php echo $modal_no; ?></button>
      </div>
    </div>
  </div>
</div>

<?php echo $footer; ?> 