<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */
 
define( 'DS', DIRECTORY_SEPARATOR);
define( 'ABSPATH', dirname(__FILE__) . DS );

$modules = array();
$modules[] = ABSPATH. '..'. DS .'..' . DS . '..' . DS . 'system' . DS . 'library' . DS . 'serwersms.php';
$modules[] = ABSPATH . 'serwersms.php';
foreach($modules as $module) {
	if(!@include($module)) {
		echo 'File '.$module.' not exist';
		exit();
	}
}

class ControllerSerwersmsEvent extends ControllerSerwersms {

    public function order_add($orderId) {

        if ($this->config->get('serwersms_logged') && $this->config->get('serwersms_logged') == 1 && $this->config->get('serwersms_order_add_flag') && $this->config->get('serwersms_order_add_flag') == 1) {

            $this->load->model('checkout/order');
            $data = $this->model_checkout_order->getOrder($orderId);
            if (empty($data))
                return false;

            $this->load->model('serwersms/message');
            $this->prepare_api();

            $message = '';
            if ($this->config->get('serwersms_order_add_value'))
                $message = $this->config->get('serwersms_order_add_value');

            $fields = array('order_id', 'customer', 'email', 'payment', 'price', 'count', 'comment');
            foreach ($fields as $field) {

                $value = '';
                if ($field == 'customer') {
                    if (isset($data['shipping_firstname']) && isset($data['shipping_lastname']))
                        $value = $data['shipping_firstname'] . ' ' . $data['shipping_lastname'];
                }
                else if ($field == 'price' && isset($data['total'])) {
                    $value = $data['total'];
                } else if ($field == 'payment' && isset($data['payment_method'])) {
                    $value = $data['payment_method'];
                } else if ($field == 'count' && isset($data['products'])) {
                    $value = count($data['products']);
                } else if (isset($data[$field])) {
                    $value = $data[$field];
                }

                $message = preg_replace("/\{" . $field . "\}/i", $value, $message);
            }

            $this->api->message = $message;
            $response = $this->api->sendSMS();
            $this->save_response($response);
        }

        return true;
    }

    public function order_edit($orderId) {

        if ($this->config->get('serwersms_logged') && $this->config->get('serwersms_logged') == 1) {

            $this->load->model('checkout/order');
            $this->load->model('serwersms/order');

            $data = $this->model_checkout_order->getOrder($orderId);
            $prev_order_id = $this->model_serwersms_order->getLastStatus($orderId);

            if (isset($data['order_status_id']) && $data['order_status_id'] != 0) {

                if ($data['order_status_id'] != $prev_order_id) {

                    $params = array(
                        5 => array(
                            'key' => 'serwersms_order_complete_flag',
                            'value' => 'serwersms_order_complete_value',
                        ),
                        2 => array(
                            'key' => 'serwersms_order_processing_flag',
                            'value' => 'serwersms_order_processing_value',
                        ),
                        7 => array(
                            'key' => 'serwersms_order_canceled_flag',
                            'value' => 'serwersms_order_canceled_value',
                        ),
                        3 => array(
                            'key' => 'serwersms_order_shipped_flag',
                            'value' => 'serwersms_order_shipped_value',
                        ),
                        15 => array(
                            'key' => 'serwersms_order_processed_flag',
                            'value' => 'serwersms_order_processed_value',
                        ),
                        10 => array(
                            'key' => 'serwersms_order_failed_flag',
                            'value' => 'serwersms_order_failed_value',
                        ),
                        16 => array(
                            'key' => 'serwersms_order_voided_flag',
                            'value' => 'serwersms_order_voided_value',
                        ),
                        11 => array(
                            'key' => 'serwersms_order_refunded_flag',
                            'value' => 'serwersms_order_refunded_value',
                        ),
                        1 => array(
                            'key' => 'serwersms_order_pending_flag',
                            'value' => 'serwersms_order_pending_value',
                        )
                    );

                    if (isset($params[$data['order_status_id']])) {

                        $param = $params[$data['order_status_id']];
                        $message = '';
                        if ($this->config->get($param['key']) && $this->config->get($param['key']) == 1) {
                            if ($this->config->get($param['value']))
                                $message = $this->config->get($param['value']);
                        }
                        if ($message != '')
                            $this->prepare_order_edit($message, $data);
                    }
                }
            }
        }

        return true;
    }

    public function customer_add($data) {

        if ($this->config->get('serwersms_logged') && $this->config->get('serwersms_logged') == 1 && $this->config->get('serwersms_register_flag') && $this->config->get('serwersms_register_flag') == 1) {

            $this->load->model('serwersms/message');
            $this->prepare_api();

            $message = '';
            if ($this->config->get('serwersms_register_value'))
                $message = $this->config->get('serwersms_register_value');

            $customer = '';
            $email = '';
            if (isset($data['firstname']) && isset($data['firstname']))
                $customer = $data['firstname'] . ' ' . $data['lastname'];

            if (isset($data['email']) && isset($data['email']))
                $email = $data['email'];

            $message = preg_replace("/\{customer\}/i", $customer, $message);
            $message = preg_replace("/\{email\}/i", $email, $message);

            $this->api->message = $message;
            $response = $this->api->sendSMS();
            $this->save_response($response);
        }

        return true;
    }

    public function save_response($response = array()) {

        if (is_array($response) && !empty($response)) {
            foreach ($response as $r) {
                $r['type'] = ($this->api->sender != '') ? 'FULL' : 'ECO';
                $r['sender'] = $this->api->sender;
                $r['test'] = $this->api->test;
                if (!$this->model_serwersms_message->save($r))
                    $this->log('Problem z zapisem danych: ' . serialize($r));
            }
        }
    }

    private function prepare_order_edit($message = '', $data = array()) {

        $phone = '';
        if (isset($data['telephone'])) {
            $phone = $this->prepare_number($data['telephone']);
        }

        if ($phone == '')
            return false;

        $this->load->model('serwersms/message');
        $this->prepare_api(false);
        $this->api->phone = $phone;

        $fields = array('order_id', 'status', 'customer', 'email', 'payment', 'price');
        foreach ($fields as $field) {

            $value = '';
            if ($field == 'customer') {
                if (isset($data['shipping_firstname']) && isset($data['shipping_lastname']))
                    $value = $data['shipping_firstname'] . ' ' . $data['shipping_lastname'];
            }
            else if ($field == 'price' && isset($data['total'])) {
                $value = $data['total'];
            } else if ($field == 'payment' && isset($data['payment_method'])) {
                $value = $data['payment_method'];
            } else if ($field == 'status' && isset($data['order_status'])) {
                $value = $data['order_status'];
            } else if (isset($data[$field])) {
                $value = $data[$field];
            }

            $message = preg_replace("/\{" . $field . "\}/i", $value, $message);
        }

        $this->api->message = $message;
        $response = $this->api->sendSMS();
        $this->save_response($response);
    }

    private function prepare_api($flag = true) {

        $this->api = new SerwersmsRequest();
        $this->api->init($this->options());

        if ($flag && $this->config->get('serwersms_phone')) {

            $data = $this->config->get('serwersms_phone');
            if (!empty($data)) {

                $data = explode(',', $data);
                $list = array();
                foreach ($data as $phone) {

                    $tmp = $this->prepare_number($phone);
                    if (!empty($tmp)) {
                        $list[] = $tmp;
                    }
                }

                if (!empty($list))
                    $this->api->phone = implode(',', $list);
            }
        }

        if ($this->config->get('serwersms_sender')) {

            $sender = $this->config->get('serwersms_sender');
            if (!empty($sender))
                $this->api->sender = $sender;
        }
    }

}