<?php

/*
  Author: SerwerSMS.pl
  Date: 2015-06
  Version: 1.0

 */

class ControllerSerwersms extends Controller {

    public $log = null;
    public $error = null;
    public $api = null;

    public function log($info = '') {

        if (is_null($this->log)) {
            $this->log = new Log('serwersms.log');
        }

        $this->log->write($info);
    }

    public function options() {

        if (!defined('SALT')) {
            define('SALT', '4gfd32lbxdgfd5hgfd5dfs');
        }

        $salt = SALT;
        $data = array();

        $fields = array(
            'login' => '',
            'password' => '',
            'unicode' => 0,
            'flash' => 0,
            'speed' => 0,
            'test' => ''
        );
        foreach ($fields as $field => $value)
            $data[$field] = $value;

        if ($this->config->get('serwersms_username'))
            $data['login'] = $this->config->get('serwersms_username');
        if ($this->config->get('serwersms_password')) {
            $encryption = new Encryption($salt);
            $data['password'] = $encryption->decrypt($this->config->get('serwersms_password'));
        }
        if ($this->config->get('serwersms_unicode'))
            $data['unicode'] = $this->config->get('serwersms_unicode');
        if ($this->config->get('serwersms_flash'))
            $data['flash'] = $this->config->get('serwersms_flash');
        if ($this->config->get('serwersms_speed'))
            $data['speed'] = $this->config->get('serwersms_speed');
        if ($this->config->get('serwersms_test'))
            $data['test'] = $this->config->get('serwersms_test');

        if ($data['unicode'] == 1)
            $data['unicode'] = 'UTF-8';
        else
            $data['unicode'] = '';

        return $data;
    }

    public function plain($string = '') {

        header('Content-Type: text/plain');
        echo $string;
        exit();
    }

    public function prepare_number($phone = '') {
 
        if ($phone != '') {
            $phone = substr(preg_replace("/[^0-9]/i", '', $phone), -9);
           
            if (strlen($phone) == 9) {
                return '+48' . $phone;
            }
        }
        return '';
    }

}