<?php
/* Name: SerwersmsRequest */

/*
* Klasa odpowiedzialna za wykonanie requestu do API, 
* obsługa odpowiedzi, parsowanie danych

Author: SerwerSMS.pl
Date: 20015-06
Version: 1.0

*/
class SerwersmsRequest {

	private $url = 'https://api1.serwersms.pl/zdalnie/';
	
    public $login = '';
    public $password = '';
	
    public $unicode = 0;
    public $flash = 0;
    public $speed = 0;
    public $test = 0;
	
    public $phone = array();
    public $message = '';
	
    public $sender = '';
	
	public $messages = array(
	
		100 => 'Błąd logowania: nie podano danych loginu lub hasła',
		101 => 'Błąd logowania: nieprawidłowy login lub hasło',
		102 => 'Błąd dostępu: abonent nie ma uprawnień do korzystania z WebAPI',
		103 => 'Konto nie jest w pełni aktywne',
		104 => 'Użytkownik nie ma uprawnień do korzystania z WebAPI',
		105 => 'Adres IP nieuprawniony do komunikacji',
		106 => 'Nie określono akcji do wykonania',
		
		1000 => 'Wyczerpano limit dostępnych wiadomości SMS ECO',
		1001 => 'Brak uprawnień do wysyłania wiadomości typu SMS ECO',
		1002 => 'Wyczerpano limit dostępnych wiadomości SMS FULL',
		1003 => 'Brak uprawnień do wysyłania wiadomości typu SMS FULL',
		1004 => 'Wyczerpano limit dostępnych wiadomości MMS',
		1005 => 'Nie posiadasz uprawnień do wysyłania wiadomości MMS',
		1006 => 'Wyczerpano limit dostępnych wiadomości SMS Głosowy',
		1007 => 'Nie posiadasz uprawnień do wysyłania wiadomości SMS Głosowy',
		1100 => 'Wysyłanie wiadomości SMS zostało zablokowane',
		1101 => 'Wiadomość jest pusta',
		1102 => 'Wiadomość przekroczyła dozwoloną ilość znaków',
		1103 => 'Błędny numer odbiorcy',
		1104 => 'Nie podano numerów telefonów',
		1105 => 'Niepoprawna wiadomość',
		1106 => 'Nie można użyć tej nazwy nadawcy',
		1107 => 'Nie posiadasz uprawnień do wysyłania wiadomości spersonalizowanych',
		1108 => 'Nieprawidłowa godzina wysyłki',
		1109 => 'Nieprawidłowy plik',
		1110 => 'Zbyt duża ilość wiadomości do przesłania. Maksymalna ilość to 100.000 SMS w jednym zgłoszeniu.',
		1111 => 'Błąd unikalności',
		1112 => 'Nie posiadasz uprawnień do wysyłania wiadomości typu Flash SMS',
		1113 => 'Nie posiadasz uprawnień do wysyłania wiadomości SMS',
	
		1200 => 'Niepoprawne znaki w usmsid',
		1201 => 'Przesłane usmsid nie są unikalne',
		1202 => 'Niezgodna ilość spersonalizowanych i usmsid',
		1203 => 'Błąd unikalności usmsid',
	
		1300 => 'Użytkownik nie posiada uprawnień do wysyłania wiadomości',
		1301 => 'Użytkownik nie ma uprawnień do wysyłania wiadomości SMS ECO',
		1302 => 'Użytkownik wyczerpał limit dostępnych wiadomości SMS ECO',
		1303 => 'Użytkownik nie ma uprawnień do wysyłania wiadomości SMS FULL',
		1304 => 'Użytkownik wyczerpał limit dostępnych wiadomości SMS FULL',
		1305 => 'Użytkownik nie posiada uprawnień do wysyłania wiadomości SMS Głosowy',
		1306 => 'Użytkownik wyczerpał limit dostępnych wiadomości SMS Głosowy',
		1307 => 'Użytkownik nie posiada uprawnień do wysyłania wiadomości MMS',
		1308 => 'Użytkownik wyczerpał limit dostępnych wiadomości MMS',
	
	
		2000 => 'Ważność smsa wygasła',
		2001 => 'Błędny numer odbiorcy',
		2002 => 'Nieobsługiwany numer',
		2003 => 'Wiadomość odrzucona',
		2004 => 'Błąd operatora',
		2005 => 'Nie odebrano połączenia',

		2100 => 'W trakcie wysyłki',
		2101 => 'Oczekiwanie',
		2102 => 'Doręczono',
		2103 => 'Niedoręczona',
		2104 => 'Zaplanowano',
		2105 => 'Niewysłano',
	
		2200 => 'Nieprawidłowy numer odbiorcy',
		2201 => 'Limit wiadomości wyczerpany',
		2202 => 'Wysyłka wiadomości jest zablokowana',
		2203 => 'Nieprawidłowa wiadomość',
		2204 => 'Błąd po stronie Operatora',
		2205 => 'Nieprawidłowa nazwa nadawcy',
		2206 => 'Numer znajduje się na czarnej liście',
		2207 => 'Wysyłka do sieci zagranicznych jest zablokowana',
		2208 => 'Brak uprawnień do wysłania wiadomości',
		2299 => 'Inny błąd',
	
		3000 => 'Brak operacji do wykonania',
		3002 => 'Nieprawidłowy numer',
		3003 => 'Numer już istnieje na liście',
		3004 => 'Nie ma takiego numeru na liście',
	
		4000 => 'Dopisano',
		4001 => 'Taki nazwa już istnieje',
		4002 => 'Brak możliwości dodania numeru jako nazwę nadawcy',
		4003 => 'Niepoprawna nazwa nadawcy',
		4004 => 'Oczekuje na autoryzacje',
		4005 => 'Autoryzowano',
		4006 => 'Odrzucono',
		4007 => 'Dezaktywowano',
	
		5000 => 'Błąd połączenia',
		5001 => 'Niepoprawny numer',
		5002 => 'Brak uprawnień do HLR',
		5003 => 'Limit zapytań HLR wyczerpany',

		6000 => 'Zbyt duży plik',
		6001 => 'Plik nie istnieje',
		6002 => 'Nieprawidłowy plik',
	
		7000 => 'Brak uprawnień do działu użytkownicy',
		7001 => 'Subkonto nie może tworzyć subkont',
		7002 => 'Login zajęty',
		7003 => 'Brak szablonu uprawnień',
		7004 => 'Nieprawidłowy login lub hasło'
	);
	
	public function getMessage($code = '') {
	
		$data = '';
		if(isset($this->messages[$code]))
			$data = $this->messages[$code];
		
		return $data;
	}
	
	public function init($options = array()){
        
		$this->login = $options['login'];
		$this->password = $options['password'];
		$this->flash = $options['flash'];
		$this->speed = $options['speed'];
		$this->test = $options['test'];
		if(isset($options['unicode']))
			$this->unicode = $options['unicode'];

    }
	
	public function checkUser(){
	
        $xml = $this->make('ilosc_sms', array());
		
		$result = $this->parseXML('ilosc_sms',$xml);
		if(is_array($result) && isset($result['ECO'])) {
			return true;
		}
			
        return false;
    }
	
	public function getInvoices() {
	
        $xml = $this->make('faktury',array(
            'operacja' => 'lista'
        ));
		
        return $this->parseXML('faktury_lista',$xml);
	
	}
	
	public function getInvoice($id = null) {

		if(is_null($id))
			return false;
	
        $result = $this->make('faktury',array(
            'faktura' => (int)$id
        ));
		
        header("Content-type: application/pdf");
        echo $result;
        exit();
		
	}
	
	public function getCountSms(){
	
        $xml = $this->make('ilosc_sms', array('pokaz_typ_konta'=>1));
		$result = $this->parseXML('ilosc_sms',$xml);

		$tmp = array();
		if(!empty($result)) {
			foreach($result as $k => $v) {
				$tmp[$k] = (string)$v;
			}
			$result = $tmp;
		}
		if(is_array($result) && isset($result['ECO'])) {
			return $result;
		}
			
        return array();
    }
	
	public function getStatus() {
	
		$xml = $this->make('pomoc',array());
		return $this->parseXML('pomoc',$xml);
	}
	
	public function addSender($name = ''){
        
        $xml = $this->make('nazwa_nadawcy',array(
            'operacja' => 'dodanie',
            'nazwa' => $name
        ));
		
        return $this->parseXML('dodaj_nadawce',$xml);
    }
	
	public function getAnswers(){
        
        $xml = $this->make('sprawdz_odpowiedzi',array(
            'operacja' => 'lista'
        ));
		
        return $this->parseXML('sprawdz_odpowiedzi',$xml);
    }
	
		
	public function getSender(){
        
        $xml = $this->make('nazwa_nadawcy',array(
            'operacja' => 'lista'
        ));
		
        return $this->parseXML('nazwa_nadawcy',$xml);
    }
	
	public function getPreSender(){
        
        $xml = $this->make('nazwa_nadawcy',array(
            'operacja' => 'lista',
            'predefiniowane' => 1
        ));
		
        return $this->parseXML('nazwa_nadawcy',$xml);
    }

	public function sendSMS(){
        
        $xml = $this->make('wyslij_sms',array(
            'numer' => $this->phone,
            'wiadomosc' => $this->message,
            'nadawca' => $this->sender,
            'flash' => $this->flash,
            'speed' => $this->speed,
            'kodowanie' => $this->unicode,
            'test' => $this->test
        ));
		
        return $this->parseXML('wyslij_sms',$xml);
    }
	
	public function getRaport($smsid){
        
		$smsidgroup = array();
        if(is_array($smsid) && !empty($smsid)){
            if(count($smsid) > 500){
                $n=0;
                foreach($smsid as $si){
                    $n++;
                    $buffor[] = $si;
                    if($n>500){
                        $smsidgroup[] = $buffor;
                        $buffor = array();
                        $n=0;
                    }
                }
                if(!empty($buffor)){
                    $smsidgroup[] = $buffor;
                }
            } else {
                $smsidgroup[] = $smsid;
            }
        } else {
            $smsidgroup[] = array($smsid);
        }
        
        foreach($smsidgroup as $sms_id){
		
            $ids = implode(",",$sms_id);
            $xml = $this->make('sprawdz_sms',array(
					'smsid' => $ids
				)
			);
            return $this->parseXML('sprawdz_sms',$xml);
        }
        
    }
	
	private function make($action = '', $vars) {
	
		if(!$action || empty($action))
			return false;
			
		$response = false;

        $vars = array_merge(array(
            'login' => $this->login,
            'haslo' => $this->password,
            'akcja' => $action,
			'kody_bledow' => 1,
			'system' => 'opencart'
        ), $vars);
		
		if(isset($vars['nadawca']) && $vars['nadawca']=='')
			$vars['kodowanie'] = '';

        if(!empty($this->login) and !empty($this->password)){
		
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $this->url);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($vars));
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($curl, CURLOPT_TIMEOUT, 60);

            $response = curl_exec($curl);
            curl_close($curl);
        }
			
        return $response;
    }
	
	private function parseXML($action, $xml_file) {
        
        if($xml_file){
            $dom = new domDocument;
            $dom->loadXML($xml_file);
            $xml = simplexml_import_dom($dom);
        } else {
            $xml = false;
        }
        
        $result = array();
        
        if (isset($xml->Blad)) {
            $result['ERR'] = $this->getMessage((string)$xml->Blad);
        } else {
		
            if ($action == 'wyslij_sms') {
			
                $index = 0;
                if (isset($xml->Odbiorcy->Skolejkowane)) {
                    foreach ($xml->Odbiorcy->Skolejkowane->SMS as $sms) {
                        $result[$index]['smsid'] = $this->xml_attribute($sms, 'id');
                        $result[$index]['number'] = $this->xml_attribute($sms, 'numer');
                        $result[$index]['date'] = $this->xml_attribute($sms, 'godzina_skolejkowania');
                        $result[$index]['status'] = 'Wysłano';
                        $result[$index]['message'] = (string) $xml->Wiadomosc;
						$result[$index]['reason'] = '';
                        $index++;
                    }
                }
				
                if (isset($xml->Odbiorcy->Niewyslane)) {
                    foreach ($xml->Odbiorcy->Niewyslane->SMS as $sms) {
                        $result[$index]['smsid'] = $this->xml_attribute($sms, 'id');
                        $result[$index]['number'] = $this->xml_attribute($sms, 'numer');
                        $result[$index]['date'] = date('Y-m-d H:i:s');
                        $result[$index]['status'] = 'Niewysłano';
                        $result[$index]['message'] = (string) $xml->Wiadomosc;
                        $result[$index]['reason'] = (int) $this->xml_attribute($sms, 'przyczyna');
                    }
                }
            }
			
            if ($action == 'sprawdz_sms') {
			
                if (isset($xml->SMS)) {
                    $i = 0;
                    foreach ($xml->SMS as $sms) {
                        $result[$i]['smsid'] = $this->xml_attribute($sms, 'id');
                        $result[$i]['number'] = $this->xml_attribute($sms, 'numer');
						$date = '';
						$fields = array('godzina_doreczenia','godzina_niedoreczenia','godzina_wyslania');
						foreach($fields as $field) {
							if($this->xml_attribute($sms,$field)!=null && $this->xml_attribute($sms,$field)!='0000-00-00 00:00:00') {
								$date = $this->xml_attribute($sms,$field);
								break;
							}
						}
                        $result[$i]['date'] = $date;
                        $result[$i]['status'] = $this->getMessage($this->xml_attribute($sms, 'stan'));
                        $result[$i]['reason'] = $this->xml_attribute($sms,'przyczyna');
                        $i++;
                    }
                }
            }
			
            if ($action == 'sprawdz_odpowiedzi') {
			
                if (isset($xml->SMS)) {
                    $i = 0;
                    foreach ($xml->SMS as $sms) {
                        $result[$i]['smsid'] = $this->xml_attribute($sms, 'id');
                        $result[$i]['message'] = $this->xml_attribute($sms, 'tresc');
                        $result[$i]['date'] = $this->xml_attribute($sms, 'data');
                        $result[$i]['number'] = $this->xml_attribute($sms, 'numer');
                        $i++;
                    }
                }
            }
			
            if($action == 'pomoc') {
			
                $result['phone'] = (string)$xml->Telefon;
                $result['info'] = (string)$xml->Infolinia;
                $result['email'] = (string)$xml->Email;
                $result['form'] = (string)$xml->Formularz;
                $result['faq'] = (string)$xml->Faq;
                if(isset($xml->Opiekun)){
                    $result['user']['name'] = (string)$xml->Opiekun->Nazwa;
                    $result['user']['email'] = (string)$xml->Opiekun->Email;
                    $result['user']['phone'] = (string)$xml->Opiekun->Telefon;
                    $result['user']['foto'] = (string)$xml->Opiekun->Foto;
                }
            }
			
			
			if ($action == 'faktury_lista') {
			
				if(isset($xml->FAKTURA)){
                    $i=0;
                    foreach($xml->FAKTURA as $innovice){
						$result[] = array(
							'id' => $this->xml_attribute($innovice,'numer'),
							'name' => $this->xml_attribute($innovice,'numer'),
							'status' => $this->xml_attribute($innovice,'stan'),
							'settled' => $this->xml_attribute($innovice,'rozliczono'),
							'price' => $this->xml_attribute($innovice,'kwota'),
							'date' => $this->xml_attribute($innovice,'termin'),
							'url' => $this->xml_attribute($innovice,'id')
						);
                        $i++;
                    }
                }
            }
			
			
			if ($action == 'nazwa_nadawcy') {
				if(isset($xml->NADAWCA)){
                    $i=0;
                    foreach($xml->NADAWCA as $sender){
					
						$value = (string)$sender;
						$result[] = array(
							'id' => $i,
							'name' => $this->xml_attribute($sender,'nazwa'),
							'system' => $this->xml_attribute($sender,'system'),
							'agree' => $this->xml_attribute($sender,'zgoda'),
							'status' => $this->getMessage($value)
						);
                        $i++;
                    }
                }
            }
			
			if ($action == 'dodaj_nadawce') {
			
				if(isset($xml->NADAWCA)){
                    $i=0;
                    foreach($xml->NADAWCA as $sender){
					
						$value = (string)$sender;
						if($value==4000) {
							$result['OK'][] = array(
								'id' => $i,
								'name' => $this->xml_attribute($sender,'nazwa'),
								'system' => $this->xml_attribute($sender,'system'),
								'agree' => $this->xml_attribute($sender,'zgoda'),
								'status' => $this->getMessage($value)
							);
						}
						else {
							$result['ERR'][] = array(
								'id' => $i,
								'name' => $this->xml_attribute($sender,'nazwa'),
								'system' => $this->xml_attribute($sender,'system'),
								'agree' => $this->xml_attribute($sender,'zgoda'),
								'status' => $this->getMessage($value)
							);
						}
                        $i++;
                    }
                }
            }

			
            if ($action == 'ilosc_sms') {
                if (isset($xml->SMS)) {
                    foreach ($xml->SMS as $sms) {
                        $result[$this->xml_attribute($sms, 'typ')] = $sms;
                    }
                }
                if(isset($xml->KONTO)){
                    $result['KONTO'] = (string) $xml->KONTO;
                }
            }
        
        }
        
        return $result;
    }
	
    private function xml_attribute($object, $attribute) {
        if (isset($object[$attribute]))
            return (string) $object[$attribute];
		if(isset($object->$attribute))
			return (string)$object->$attribute;
    }
}
?>